﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.UI;
public class Personagem : MonoBehaviour {
	float Vx; 	//velocidade em x
	float Vy;	//velocidade em y
	float VelocidadeHorizontal;
	float VelocidadePular;
	float DirecaoHorizontal; //variavel que armazena a direção: para esquerda, para a direita ou parado
	Rigidbody2D CorpoRigido; //corpo rígido do elemento onde o script foi inserido.
	CircleCollider2D Colisor; // colisor do elemento onde o script foi inserido.
	Text UiTextPontos; // Componente UI do tipo TEXT
	int QtdPontos;	// armazena a quantidade de pontos

	void Start () {
		QtdPontos = 0;
		VelocidadeHorizontal = 5;	//incia a velocidade de andar na horizontal(direita e esquerda)
		VelocidadePular	= 5;		//inicia a velocidade de pular
		CorpoRigido = GetComponent<Rigidbody2D> ();		//recupera o corpo rigido inserido no elemento que possui o script(corpo rígido do personagem)
		Colisor = GetComponent<CircleCollider2D> (); 	//recupera o colisor inserido no elemento que possui o script(colisor do personagem)	
		//inicializa com componente UI de Texto
		//encontra o componente com a tag “qtdPontos” e recupera o Objeto Text.
		UiTextPontos = GameObject.FindGameObjectWithTag ("qtdPontos").GetComponent<Text> ();
		CorpoRigido.freezeRotation = true;				//impede que rotacione no eixo.
		//inicia a escala de gravidade com 1 - caso utilize MovimentoVertical()  ao invés Pular() gravityScale = 1 deve ser igual 0
		CorpoRigido.gravityScale = 1;		
	}
	    
	//"void Update ()" Executado uma vez por frame. 
	void Update () {
		MovimentoHorizontal();
		Pular();
		//MovimentoVertical ();
	}
	void Pular(){
		//verdadeiro(true) se o botão de Jump foi pressionado caso contrário igual a false
		bool apertou = Input.GetButtonDown ("Jump");
		
		//verdadeiro(true) se o personagem estiver tocando outro collider
		bool tocou = Colisor.IsTouchingLayers ();

		if (apertou == true && tocou == true) {
			// esse bloco só é executado se for apertado o botão de Jump
			// e se o personagem estiver tocando em alguma coisa com colidder
			Vx = CorpoRigido.velocity.x;
			Vy = VelocidadePular;
			Vector2 pulo = new Vector2 (Vx, Vy);
			CorpoRigido.velocity = pulo;
		}
	}

	void MovimentoHorizontal(){
		//DirecaoHorizontal Recebe até 1 quando precionado o botão para direita e até -1 para esquerda. Quando parado Recebe 0.
		DirecaoHorizontal = Input.GetAxis ("Horizontal");
		// Gera uma nova velocidade em x
		Vx = VelocidadeHorizontal * DirecaoHorizontal;
		 //Recupera a velocidade em y que o personagem já possui
		Vy = CorpoRigido.velocity.y;
		//Cria um vetor de velocidade com os valores da velocidade em x e da velocidade em y (vx e vy)
		Vector2 andar = new Vector2 (Vx, Vy);
		// O vetor de velocidade é adicionado a velocidade do corpo rígido do personagem
		CorpoRigido.velocity = andar;
	}

	void OnCollisionEnter2D(Collision2D objetoTocado){
		string tagTocada = objetoTocado.gameObject.tag; 
		if (tagTocada == "tipo1" ) {
			QtdPontos=QtdPontos+1;
			string textoPontos= QtdPontos.ToString();
			UiTextPontos.text = textoPontos;
			Destroy (objetoTocado.gameObject);
		}
		if (tagTocada == "tipo2") {
			QtdPontos=QtdPontos+2;
			string textoPontos= QtdPontos.ToString();
			UiTextPontos.text = textoPontos;
			Destroy (objetoTocado.gameObject);
		}
	
	}
}
